/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Stefan Lienard
   co-programmer: ...
*/

#include "mapped_water.h"
#include "util/loading/load_param.h"
#include "util/loading/factory.h"
#include "material.h"


CREATE_FACTORY(MappedWater, CL_MAPPED_WATER);


MappedWater::MappedWater(const TiXmlElement* root)
{
  this->setClassID(CL_MAPPED_WATER, "MappedWater");
  this->toList(OM_ENVIRON);
  
  if (root != NULL)
    this->loadParams(root);
}

MappedWater::~MappedWater()
{
  
}

void MappedWater::loadParams(const TiXmlElement* root)
{
  WorldEntity::loadParams(root);

  LoadParam(root, "waterHeight", this, MappedWater, setHeight);
}


void MappedWater::draw() const
{
  glPushMatrix(); 
 
  /*
  glTranslatef (this->getAbsCoor ().x,
                this->getAbsCoor ().y,
                this->getAbsCoor ().z);
  */
  glTranslatef(0,this->waterHeight,0);

  //glEnable(GL_LIGHTING);

  Material mat;
  mat.setDiffuseMap("pictures/ground.tga", GL_TEXTURE_2D, 0);
  //mat.setDiffuseMap("pictures/sky-replace.jpg", GL_TEXTURE_2D, 1);
  //mat.setTransparency(1.0);
  //mat.setDiffuse(1.0, 0, .1);
  mat.select();

  glBegin(GL_QUADS);
    glNormal3f(0,1,0);
    glTexCoord2f(0,0);
    //glMultiTexCoord2f(GL_TEXTURE1, 0,0);
    glVertex3f(0,0,0);
    glTexCoord2f(1,0);
    //glMultiTexCoord2f(GL_TEXTURE1, 1,0);
    glVertex3f(100,0,0);
    glTexCoord2f(1,1);
    //glMultiTexCoord2f(GL_TEXTURE1, 1,1);
    glVertex3f(100,0,-100);
    glTexCoord2f(0,1);
    //glMultiTexCoord2f(GL_TEXTURE1, 0,1);
    glVertex3f(0,0,-100);
  glEnd();

  glPopMatrix();
}

void MappedWater::tick(float dt)
{

}

void MappedWater::setHeight(float height)
{
  this->waterHeight = height;
}

void MappedWater::activateReflection() {}
void MappedWater::deactivateReflection() {}

void MappedWater::activateRefraction() {}
void MappedWater::deactivateRefraction() {}
